"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var bindable_bloc_1 = require("bindable-bloc");
var yuni_chanz_react_1 = require("yuni-chanz-react");
var FirebaseApi_1 = __importDefault(require("./FirebaseApi"));
var FirebaseStreamableQueryApi = /** @class */ (function (_super) {
    __extends(FirebaseStreamableQueryApi, _super);
    function FirebaseStreamableQueryApi() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.streamedData = new bindable_bloc_1.Bindable([]);
        _this.streamCanceller = null;
        return _this;
    }
    FirebaseStreamableQueryApi.prototype.startStream = function () {
        var _this = this;
        this.stopStream();
        this.getQuery().onSnapshot(function (snapshot) { return _this.onSnapshot(snapshot); });
    };
    FirebaseStreamableQueryApi.prototype.stopStream = function () {
        if (this.streamCanceller !== null) {
            this.streamCanceller();
            this.streamCanceller = null;
        }
    };
    FirebaseStreamableQueryApi.prototype.request = function () {
        return __awaiter(this, void 0, void 0, function () {
            var query, response, data, e_1;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        query = this.getQuery();
                        return [4 /*yield*/, query.get()];
                    case 1:
                        response = _a.sent();
                        data = response.docs.map(function (doc) { return _this.parseData(doc); });
                        return [2 /*return*/, yuni_chanz_react_1.ApiResponse.success(data)];
                    case 2:
                        e_1 = _a.sent();
                        return [2 /*return*/, yuni_chanz_react_1.ApiResponse.failed(e_1, this.getRequestErrorMessage())];
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Returns the error message for the default request implementation.
     */
    FirebaseStreamableQueryApi.prototype.getRequestErrorMessage = function () {
        return "Error while requesting data.";
    };
    /**
     * Event called when the new stream of data has been received.
     */
    FirebaseStreamableQueryApi.prototype.onSnapshot = function (querySnapshot) {
        var _this = this;
        this.streamedData.value = querySnapshot.docs.map(function (doc) {
            return _this.parseData(doc);
        });
    };
    return FirebaseStreamableQueryApi;
}(FirebaseApi_1.default));
exports.default = FirebaseStreamableQueryApi;
