"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var firebase_1 = __importDefault(require("firebase"));
var yuni_chanz_react_1 = require("yuni-chanz-react");
var FirebaseModelConverter = /** @class */ (function (_super) {
    __extends(FirebaseModelConverter, _super);
    function FirebaseModelConverter() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Encodes the specified Date instance into a Firestore date representation.
     */
    FirebaseModelConverter.prototype.encodeDate = function (value) {
        return firebase_1.default.firestore.Timestamp.fromDate(value);
    };
    FirebaseModelConverter.prototype.decodeDate = function (value) {
        if (value instanceof firebase_1.default.firestore.Timestamp) {
            return value.toDate();
        }
        return _super.prototype.decodeDate.call(this, value);
    };
    return FirebaseModelConverter;
}(yuni_chanz_react_1.ModelConverter));
exports.default = FirebaseModelConverter;
