import { FBTimestamp } from "../api/FirebaseTypes";
import { ModelConverter } from "yuni-chanz-react";
export default abstract class FirebaseModelConverter<T = any> extends ModelConverter<T> {
    /**
     * Encodes the specified Date instance into a Firestore date representation.
     */
    encodeDate(value: Date): FBTimestamp;
    decodeDate(value: any): Date | null;
}
